//////////////////////////////////////////////////////////////////
//
// ISpyUMain.c - Main ISpyU Window handling code
// 
//   Copyright (C) 1998 Paul Holden
//   paulh@javigate.com
// 
//   File Created: 6  Nov 1998
//   Last Update:  16 Nov 1998
//
//   For more info and more recent version see:
//     http://www.javigate.com/ICQ/
//
//  Standard Disclaimer:
//  --------------------
//    Note that I am in no way affiliate with Mirabilis. I have found all these
//    information by tracing UDP packets (this complies with Mirabilis License
//    agreement). This information are unofficial and may be incorrect.
//
//    This program is provided "as is" and comes with no warranty,
//    express if implied. Use this program at you own risk. Yadda Yadda.
//
//
// This file isn't substantially commented - mainly because it's a work
// in progress and I'll probably hack huge swathes of it out quite soon
// 
// Make sure you link with:
//   wsock32.lib
//   comctl32.lib
//   And all the standard windows libs.

//  Things to do:
//  -------------
//
//    Read changelog.txt for stuff done/fixed since last release.
//
//    Allow passwords, UIDs, IP addresses etc to be optionally hidden (i.e.
//     replaced with "****" when logfiles are saved)
//
//    Add v4 decoding support - it *kinda* recognised v4, but doesn't decode it. Arse.
//
//    Add filters so that only certain messages will be logged (or shown)
//
//    Add ability to modify packets before sending them to server
//     (i.e. decrypt, change a few fields, re-encrypt and pass on) 
//
//    or to the client...
//

#include <winsock2.h>
#include <windows.h>
#include <winuser.h>
#include <commctrl.h>
#include <stdio.h>

#include "resource.h"
#include "ISpyUMain.h"
#include "SocketHandler.h"

HINSTANCE g_hInstance     = NULL;
HWND	  g_hMainWindow   = NULL;
HWND	  g_hStatusWindow = NULL;
HWND	  g_hListWindow   = NULL;
HWND	  g_hPropPage	  = NULL;

HWND	  g_hOutputWindow = NULL;

// Some strings. These are filled in from the string table
char g_szMainWindowClassName[256];
char g_szOutputWindowClassName[256];
char g_szAppName[256];
char g_szOutputName[256];


ICQMsg *g_pFirstICQMsg = NULL;

#define NUM_COLUMNS 6
#define MAX_SERVERS 10

BOOL	g_bListBits[NUM_COLUMNS] = {TRUE, TRUE, TRUE, TRUE, TRUE, TRUE};

DWORD	g_dwLastMessageTime = 0;

char	g_szNewServerName[256];
unsigned short g_nNewServerPort;

unsigned int	g_nNumServers = 0;
ServerInfo		g_Servers[MAX_SERVERS];

// A few options about how to format the hex dump:
int			g_nLineNumType = 1;		// 1 == Hex, 2 == Dec (anything else == none...)
int			g_nBytesPerLine = 16;
BOOL		g_bShowASCII = TRUE;
BOOL		g_bShowHeader = TRUE;
BOOL		g_bShowBody   = TRUE;
BOOL		g_bConciseHeader = TRUE;

/////////////////////////////////////////////////////////////////////
int WINAPI WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst,
				   LPSTR lpszArgs, int nWinMode) {
	char szBuffer[1024];
	unsigned int nNumServerToTry;

	MSG msg;
	BOOL bResult, bProcessed;

	g_hInstance = hThisInst;

    LoadString(g_hInstance, IDS_MAINWINDOWCLASSNAME, g_szMainWindowClassName, sizeof(g_szMainWindowClassName)); 
    LoadString(g_hInstance, IDS_OUTPUTWINDOWCLASSNAME, g_szOutputWindowClassName, sizeof(g_szOutputWindowClassName)); 
    LoadString(g_hInstance, IDS_ISU_APPNAME, g_szAppName, sizeof(g_szAppName)); 
    LoadString(g_hInstance, IDS_ISU_OUTPUTNAME, g_szOutputName, sizeof(g_szOutputName)); 


	if (InitApplication() == FALSE) return 0;

	if (g_nNumServers == 0)
		AddServer("icq.mirabilis.com", 4000);

	g_hMainWindow = CreateWindow(
		g_szMainWindowClassName,
		g_szAppName,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		650,
		300,
		HWND_DESKTOP,
		NULL,
		g_hInstance,
		NULL,
	);
	if (g_hMainWindow == NULL) return 0;

	UpdateListControl();
	ShowWindow(g_hMainWindow, nWinMode);
	UpdateWindow(g_hMainWindow);

	// Attempt to create our port for listening to clients
	if (InitClientSocket(g_hMainWindow, szBuffer) == FALSE) {
		MessageBox(NULL, szBuffer, g_szAppName, MB_OK);
	}

	if (InitSpoofServerSocket(g_hMainWindow, szBuffer) == FALSE) {
		MessageBox(NULL, szBuffer, g_szAppName, MB_OK);
	}

	nNumServerToTry = 0;
	while (nNumServerToTry < g_nNumServers &&
		   InitServerSocket(g_hMainWindow, g_Servers[nNumServerToTry].szServerName,
										   g_Servers[nNumServerToTry].nPort,
										   szBuffer) == FALSE) {
		MessageBox(NULL, szBuffer, g_szAppName, MB_OK);
		nNumServerToTry++;
	}

	while (bResult = GetMessage(&msg, (HWND)NULL, 0,0)) {
		if (bResult == -1) {
			// There was an error...
		}

		bProcessed = FALSE;
		if (g_hPropPage) {
			if (PropSheet_IsDialogMessage(g_hPropPage, &msg)) {
				if (PropSheet_GetCurrentPageHwnd(g_hPropPage) == NULL) {
					DestroyWindow(g_hPropPage);
				}
				bProcessed = TRUE;
			}
		}
		if (!bProcessed) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	FiniWinSock();

	WriteConfig();

	// Delete all the messages from the list.
	DestroyICQMsgList(&g_pFirstICQMsg);

	return msg.wParam;
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

BOOL
AddServer(char *szName, unsigned short nPort) {
	if (g_nNumServers < MAX_SERVERS) {

		// Add this as server #g_nNumServers...
		strcpy(g_Servers[g_nNumServers].szServerName, szName);
		g_Servers[g_nNumServers].nPort = nPort;
		g_nNumServers++;
		return TRUE;

	} else {
		return FALSE;
	}
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

BOOL
InitApplication(void) {

    WNDCLASS wc; 
 
    // Register the frame window class. 
 
    wc.style         = 0; 
    wc.hInstance     = g_hInstance; 
    wc.cbClsExtra    = 0; 
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW); 

    wc.lpfnWndProc   = (WNDPROC)MainWndProc; 
    wc.cbWndExtra    = 0; 
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION); 
    wc.hbrBackground = (HBRUSH) (COLOR_APPWORKSPACE + 1); 
    wc.lpszMenuName  = MAKEINTRESOURCE(IDR_ISPYU_MENU); 
    wc.lpszClassName = g_szMainWindowClassName; 
 
    if (RegisterClass (&wc) == FALSE) 
        return FALSE; 

    wc.style         = 0; 
    wc.hInstance     = g_hInstance; 
    wc.cbClsExtra    = 0; 
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW); 

    wc.lpfnWndProc   = (WNDPROC)OutputWndProc; 
    wc.cbWndExtra    = 0; 
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION); 
    wc.hbrBackground = (HBRUSH) (COLOR_APPWORKSPACE + 1); 
    wc.lpszMenuName  = NULL; 
    wc.lpszClassName = g_szOutputWindowClassName; 
 
    if (RegisterClass (&wc) == FALSE) 
        return FALSE; 

	// Read Basic configuration details
	ReadConfig();

	return TRUE; 
}

void
ReadConfig(void) {
	int i, nNumServers;
	char szServerName[256];
	int nPort;			// Not ushort as we need to pass address on int value to ReadRegValue
	int nBool;			// Not BOOL as we need to ensure is right size for ReadRegValue

	// Reset Server list:
	g_nNumServers = 0;

	ReadRegValue("NumServers", &nNumServers, 0, 0);
	for (i = 0; i < nNumServers; i++) {
		// Read in info for each server...
		ReadRegString("ServerName", szServerName, sizeof(szServerName), "icq.mirabilis.com", i+1);
		ReadRegValue("ServerPort", &nPort, 4000, i+1);
		AddServer(szServerName, (unsigned short)nPort);
	}

	for (i = 1; i < NUM_COLUMNS; i++) {
		ReadRegValue("ColumnView", &nBool, TRUE, i);
		g_bListBits[i] = (nBool) ? TRUE : FALSE; // Used to ensure nVis is 1 or 0 (it might not matter..)
	}

	ReadRegValue("ProxyPort", &nPort, 5001, 0);
	SetProxyPort((unsigned short)nPort);
	ReadRegValue("SpoofServPort", &nPort, 4000, 0);
	SetSpoofServPort((unsigned short)nPort);

	// Hex Dump stuff
	ReadRegValue("ShowHeader", &nBool, TRUE, 0);
	g_bShowHeader = (nBool) ? TRUE : FALSE;

	ReadRegValue("ConciseHeader", &nBool, TRUE, 0);
	g_bConciseHeader = (nBool) ? TRUE : FALSE;

	ReadRegValue("ShowBody", &nBool, TRUE, 0);
	g_bShowBody = (nBool) ? TRUE : FALSE;

	ReadRegValue("LineNumbers", &g_nLineNumType, 1, 0);	// Default == Hex
	ReadRegValue("BytesPerLine", &g_nBytesPerLine, 16, 0);
	if (g_nBytesPerLine < 1) g_nBytesPerLine = 1;
	if (g_nBytesPerLine > 64) g_nBytesPerLine = 64;

	ReadRegValue("ShowASCII", &nBool, TRUE, 0);
	g_bShowASCII = (nBool) ? TRUE : FALSE;

}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

void
WriteConfig(void) {
	unsigned int i;
	WriteRegValue("NumServers", g_nNumServers, 0);
	for (i = 0; i < g_nNumServers; i++) {
		// Read in info for each server...
		WriteRegString("ServerName", g_Servers[i].szServerName, i+1);
		WriteRegValue("ServerPort", g_Servers[i].nPort, i+1);
	}

	for (i = 1; i < NUM_COLUMNS; i++) {
		WriteRegValue("ColumnView", g_bListBits[i], i);
	}

	WriteRegValue("ProxyPort", GetProxyPort(),  0);
	WriteRegValue("SpoofServPort", GetSpoofServPort(),  0);

	// Hex Dump stuff
	WriteRegValue("ShowHeader", g_bShowHeader, 0);
	WriteRegValue("ConciseHeader", g_bConciseHeader, 0);
	WriteRegValue("ShowBody", g_bShowBody, 0);
	WriteRegValue("LineNumbers", g_nLineNumType, 0);
	WriteRegValue("BytesPerLine", g_nBytesPerLine, 0);
	WriteRegValue("ShowASCII", g_bShowASCII, 0);
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
// pICQMsg = the message to display...
void
OpenOutputWindow(ICQMsg *pICQMsg) {

	if (IsWindow(g_hOutputWindow)) {
		// Bring to front etc.
		SetForegroundWindow(g_hOutputWindow);
	} else {
		g_hOutputWindow = CreateWindow(
			g_szOutputWindowClassName,
			g_szOutputName,
			WS_OVERLAPPEDWINDOW|WS_VISIBLE,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			600,
			400,
			g_hMainWindow,
			NULL,
			g_hInstance,
			NULL,
		);
		if (g_hOutputWindow == NULL) return;
	}

	// Now tell Output window to update...
	SendMessage(g_hOutputWindow, WM_SETICQMSG, 0, (LPARAM)pICQMsg);
}


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
LRESULT CALLBACK
MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) {

	RECT rc;
	static char szBuffer[1024];
	ICQMsg *pICQMsg;

	static DWORD nLastTick = 0;
	static BOOL  bSetTitle = FALSE;

	switch (message) {
		case WM_CREATE:
			{
				GetClientRect(hwnd, &rc);

				InitCommonControls();  
				
				g_hStatusWindow = CreateStatusWindow(WS_CHILD|WS_VISIBLE, g_szAppName, hwnd, 1);
				if (g_hStatusWindow == NULL) {
					MessageBox(NULL, "Error creating StatusBar. ?!", g_szAppName, MB_OK);
					return -1;
				}

				// Ensure that the common control DLL is loaded, and then create 
				// the list control.
				g_hListWindow = CreateListView(hwnd);
				if (g_hListWindow == NULL) {
					MessageBox(NULL, "Error creating List Control. ?!", g_szAppName, MB_OK);
					return -1;
				}

				// Set all the columns etc of the list control
				UpdateListControl();

				// Check if we're online (or in spoof mode) and set info...
				SendMessage(g_hStatusWindow, SB_SETTEXT, (WPARAM)1, (LPARAM)"Ok");

				SetTimer(hwnd, 1, 1000, NULL);
			}
			return 0; 
		case WM_DESTROY:
			{
				KillTimer(hwnd, 1);
				PostQuitMessage(0);
			}
			return 0;
		case WM_TIMER:
				if ((GetTickCount() - g_dwLastMessageTime) > 3000) {
					Main_SetStatus("Waiting...");
				}
			return 0;
		case WSN_READYFORCLIENTREAD:
			{
				if (WSAGETSELECTEVENT(lParam) == FD_READ) {
					if (pICQMsg = ProcessClientSocket(hwnd, szBuffer)) {
						AddICQMsgTail(&g_pFirstICQMsg, pICQMsg);
						AddListViewItem(g_hListWindow, pICQMsg);
						Main_SetStatus(szBuffer);
					} else {
						Main_SetStatus(szBuffer);
					}

				}
			}
			return 0;
		case WSN_READYFORSERVERREAD:
			{
				if (WSAGETSELECTEVENT(lParam) == FD_READ) {
					if (pICQMsg = ProcessServerSocket(hwnd, szBuffer)) {
						AddICQMsgTail(&g_pFirstICQMsg, pICQMsg);
						AddListViewItem(g_hListWindow, pICQMsg);
					}
					Main_SetStatus(szBuffer);
				}
			}
			return 0;

		case WSN_READYFORSPOOFSERVREAD:
			{
				if (WSAGETSELECTEVENT(lParam) == FD_READ) {
					ProcessSpoofServSocket(hwnd, szBuffer);
					Main_SetStatus(szBuffer);
				}
			}
			return 0;

		case WM_COMMAND:
			return Main_Command(hwnd, wParam, lParam);
			break;
		case WM_LBUTTONDBLCLK:
			MessageBox(hwnd, "DblClicked", "", MB_OK);
			break;

		case WM_NOTIFY:      // Branch depending on the specific notification message. 
			switch (((LPNMHDR) lParam)->code) {  
				case NM_DBLCLK:
					{
						LV_HITTESTINFO hti;
						LV_ITEM lvItem;
						BOOL bGotItem;
						int nItem;

						GetCursorPos(&hti.pt);
						ScreenToClient(hwnd, &hti.pt);

						hti.flags = LVHT_ONITEM;
						nItem = ListView_HitTest(g_hListWindow, &hti);

						// Display info about this item
						if (nItem >= 0) {
							lvItem.mask = LVIF_PARAM;
							lvItem.iItem = nItem;
							lvItem.iSubItem = 0;

							bGotItem = ListView_GetItem(g_hListWindow, &lvItem);
							if (bGotItem) {
								OpenOutputWindow((ICQMsg *)lvItem.lParam);
							}
						}

					}
					break;

				// Process LVN_GETDISPINFO to supply information about 
				// callback items.
				case LVN_GETDISPINFO: 
					Main_OnGetDispInfo((LV_DISPINFO *) lParam);
					break;  

				// Process LVN_ENDLABELEDIT to change item labels after 
				// in-place editing.
				case LVN_ENDLABELEDIT: 
					return Main_OnEndLabelEdit((LV_DISPINFO *) lParam);

				// Process LVN_COLUMNCLICK to sort items by column. 
				case LVN_COLUMNCLICK:
					#define pnm ((NM_LISTVIEW *) lParam) 
					ListView_SortItems(
						pnm->hdr.hwndFrom, 
						ListViewCompareFunc,
						(LPARAM) (pnm->iSubItem) 
						);
					#undef pnm 
					break; 
			}
			break; 

		case WM_PAINT:
			{
				PAINTSTRUCT lpPaint;
				HDC hdc = BeginPaint(hwnd, &lpPaint);
				EndPaint(hwnd, &lpPaint);
			}
			return 0;
        case WM_SETFOCUS:
			SetFocus(g_hListWindow);
			return 0; 
         case WM_SIZE:  
			// Initialise the parts of the status window..
			return Main_Size(hwnd, wParam, lParam);


	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}

///////////////////////////////////////////////////////////////////
// Initialise the parts of the status window..
LRESULT
Main_Size(HWND hwnd, WPARAM wParam, LPARAM lParam) {
	int parts[2];
	RECT rc, rcs;
	//HDC hdc;
	//SIZE size1, size2;
	int nStatusWidth;
	int nListWidth, nListHeight;

	SendMessage(g_hStatusWindow, WM_SIZE, wParam, lParam);

	GetClientRect(hwnd, &rc);
	GetWindowRect(g_hStatusWindow, &rcs);

	// Find the maximum width of the two mode status messages...
	//hdc = GetDC(hwnd);

	//GetTextExtentPoint32(hdc, g_szProxyStatus, strlen(g_szProxyStatus), &size1);
	//GetTextExtentPoint32(hdc, g_szSpoofStatus, strlen(g_szSpoofStatus), &size2);
	//nStatusWidth = (size1.cx > size2.cx) ? size1.cx : size2.cx;
	nStatusWidth = 60;

	//ReleaseDC(hwnd, hdc);

	parts[0] = rc.right - (nStatusWidth + 4);
	parts[1] = rc.right;

	// Now make status window setup parts..
	SendMessage(g_hStatusWindow, SB_SETPARTS, (WPARAM)2, (LPARAM)parts);

	nListWidth = rc.right - rc.left;
	nListHeight = (rc.bottom - rc.top) - (rcs.bottom-rcs.top);
	MoveWindow(g_hListWindow, 0, 0, nListWidth, nListHeight, TRUE); 

	return 0;
}

// Set the status of the message bar. This resets the 
// timer countdown, and the message is removed in a few seconds.
void
Main_SetStatus(char *szMessage) {
	// Set the timer here...
	g_dwLastMessageTime = GetTickCount();

	SendMessage(g_hStatusWindow, SB_SETTEXT,  (WPARAM)0, (LPARAM)szMessage);

}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
LRESULT
Main_Command(HWND hwnd, WPARAM wParam, LPARAM lParam) {

	switch (LOWORD(wParam)) {

		// File menu commands
		case IDM_OPEN:
			OpenMessageFile(hwnd);
			return 0;
		case IDM_SAVE:
			// Write messages
			SaveMessageFile(hwnd);
			return 0;
		case IDM_EXIT:
			PostQuitMessage(0);
			return 0;

		// View commands...
		case IDM_SHOWMESSAGES:
			OpenOutputWindow(NULL);
			return 0;

		case IDM_SHOWFROM:
			g_bListBits[1] = !g_bListBits[1];
			UpdateListControl();
			return 0;
		case IDM_SHOWPROTOCOL:
			g_bListBits[2] = !g_bListBits[2];
			UpdateListControl();
			return 0;
		case IDM_SHOWSEQNUMS:
			g_bListBits[3] = !g_bListBits[3];
			UpdateListControl();
			return 0;
		case IDM_SHOWTIMESTAMP:
			g_bListBits[4] = !g_bListBits[4];
			UpdateListControl();
			return 0;
		case IDM_SHOWEXTRAINFO:
			g_bListBits[5] = !g_bListBits[5];
			UpdateListControl();
			return 0;

		case IDM_OPTIONS:
			OpenPropPage(PAGE_MAIN);
			return 0;

		// Help menu commands
		case IDM_ABOUT:
			DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_ABOUT_DIALOG), hwnd, (DLGPROC)AboutDlgProc);
			return 0;
	}
	return DefWindowProc(hwnd, WM_COMMAND, wParam, lParam);
}

// Load messages from disk
void
OpenMessageFile(HWND hwnd) {
	OPENFILENAME ofn;
	char szFile[MAX_PATH], szFileTitle[MAX_PATH];
	ICQMsg *pICQMsg;

	strcpy(szFile, "");
	strcpy(szFileTitle, "");

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.nFilterIndex = 1; 
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = MAX_PATH;
	ofn.lpstrFilter = "ISpyU Logfile (*.isu)\0*.isu\0All Files (*.*)\0*.*\0";
	ofn.lpstrDefExt = "isu";
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.hInstance = g_hInstance;

	ofn.hwndOwner = hwnd;

	if(GetOpenFileName(&ofn) == FALSE)
		return;

	// Delete message list...
	ListView_DeleteAllItems(g_hListWindow);
	DestroyICQMsgList(&g_pFirstICQMsg);

	// Read messages.
	if ((g_pFirstICQMsg = ReadICQMessages(ofn.lpstrFile)) == NULL) {
		MessageBox(hwnd, "Problem Reading Messages", g_szAppName, MB_OK);
	}

	// Initialize list..
	pICQMsg = g_pFirstICQMsg;
	while (pICQMsg) {
		AddListViewItem(g_hListWindow, pICQMsg);
		pICQMsg = pICQMsg->pNextMsg;
	}

}

// Save the messages to disk...
void
SaveMessageFile(HWND hwnd) {
	OPENFILENAME ofn;
	char szFile[MAX_PATH], szFileTitle[MAX_PATH];

	strcpy(szFile, "");
	strcpy(szFileTitle, "");

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.nFilterIndex = 1; 
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = MAX_PATH;
	ofn.lpstrFilter = "ISpyU Logfile (*.isu)\0*.isu\0All Files (*.*)\0*.*\0";
	ofn.lpstrDefExt = "isu";
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	ofn.hInstance = g_hInstance;

	ofn.hwndOwner = hwnd;

	if(GetSaveFileName(&ofn) == FALSE)
		return;

	if (WriteICQMessages(ofn.lpstrFile, g_pFirstICQMsg) == FALSE) {
		MessageBox(hwnd, "Problem Writing Messages", g_szAppName, MB_OK);
	}

}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
LRESULT CALLBACK
OutputWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) {

	RECT rc;
	static HWND hEditWnd;

	switch (message) {
		case WM_CREATE:
			{
				hEditWnd = CreateWindow(
					"EDIT",					// Edit box
					"",						// No title
					WS_CHILD|WS_BORDER|WS_VISIBLE|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL|WS_HSCROLL|WS_VSCROLL,
					CW_USEDEFAULT,			// Default x/y w/h (set on WM_SIZE message)
					CW_USEDEFAULT,
					CW_USEDEFAULT,
					CW_USEDEFAULT,
					hwnd,					// Our parent
					NULL,					// No menu
					g_hInstance,
					NULL					// No creation data
					);

				if (hEditWnd == NULL) return -1;

				SendMessage(hEditWnd, WM_SETFONT, (WPARAM)GetStockObject(ANSI_FIXED_FONT), (LPARAM)MAKELPARAM(FALSE, 0));
			}
			return 0; 
		case WM_DESTROY:
			{
				g_hOutputWindow = NULL;
			}
			return 0;

		case WM_SETICQMSG:
			{
				// Initialise fields to reflect pICQMsg in lParam
				SendMessage(hEditWnd, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"");
				Output_GetMsgText((ICQMsg *)lParam, hEditWnd);


			}
			return 0;
		//case WM_COMMAND:
		//	return Main_Command(hwnd, wParam, lParam);
		//	break;

		case WM_PAINT:
			{
				PAINTSTRUCT lpPaint;
				HDC hdc = BeginPaint(hwnd, &lpPaint);
				EndPaint(hwnd, &lpPaint);
			}
			return 0;
          case WM_SIZE:  
			// Resize edit box etc
			GetClientRect(hwnd, &rc);
			MoveWindow(hEditWnd, 0,0, rc.right-rc.top, rc.bottom-rc.top, TRUE);
            return 0; 
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}

// Append some text to the contents of an EditBox
void
AppendToEdit(HWND hEditWnd, char *lpBuffer) {
	int nLen = SendMessage(hEditWnd, WM_GETTEXTLENGTH, 0,0);
	SendMessage(hEditWnd, EM_SETSEL, (WPARAM)nLen, (LPARAM)nLen);
	SendMessage(hEditWnd, EM_REPLACESEL, (WPARAM)FALSE, (LPARAM)lpBuffer);
	
}


// The main callback function for the HexDump dialog proc.
// I'll probably make this into a standard resizable window soon -
// it's a bit restrictive having a fixed size dialog box..
void
Output_GetMsgText(ICQMsg *pCurrentICQMsg, HWND hEditWnd) {
	ICQMsg *pICQMsg;
	char szBuffer[1024];

	if (pCurrentICQMsg != NULL) {
		if (g_bShowHeader || g_bShowBody == FALSE) {
			if (g_bConciseHeader) {
				// Concise..
				GetICQMsgHeaderInfo(&g_pFirstICQMsg, pCurrentICQMsg, szBuffer);
				strcat(szBuffer, "\r\n");
				AppendToEdit(hEditWnd, szBuffer);
			} else {
				// Verbose...
				GetICQMsgInfo(pCurrentICQMsg, szBuffer);
				strcat(szBuffer, "\r\n");
				AppendToEdit(hEditWnd, szBuffer);
			}
		}
		if (g_bShowBody) {
			HexDump(szBuffer, pCurrentICQMsg->pDecryptedData, pCurrentICQMsg->nMsgLen);
			AppendToEdit(hEditWnd, szBuffer);
		}

	} else {
		// Blast everything to the screen
		pICQMsg = g_pFirstICQMsg;
		while (pICQMsg) {

			if (g_bConciseHeader) {
				// Concise..
				GetICQMsgHeaderInfo(&g_pFirstICQMsg, pICQMsg, szBuffer);
				strcat(szBuffer, "\r\n");
				AppendToEdit(hEditWnd, szBuffer);
			} else {
				// Verbose...
				GetICQMsgInfo(pICQMsg, szBuffer);
				strcat(szBuffer, "\r\n");
				AppendToEdit(hEditWnd, szBuffer);

				strcpy(szBuffer, "Encrypted:\r\n");
				AppendToEdit(hEditWnd, szBuffer);
				HexDump(szBuffer, pICQMsg->pData, pICQMsg->nMsgLen);
				strcat(szBuffer, "\r\n");
				AppendToEdit(hEditWnd, szBuffer);

				strcpy(szBuffer, "Decrypted:\r\n");
				AppendToEdit(hEditWnd, szBuffer);
				HexDump(szBuffer, pICQMsg->pDecryptedData, pICQMsg->nMsgLen);
				strcat(szBuffer, "\r\n");
				AppendToEdit(hEditWnd, szBuffer);
			}

			pICQMsg = pICQMsg->pNextMsg;
		}
	}
}


void
HexDump(char *lpBuffer, unsigned char *data, int size) {
	char szTemp[1024];
	LONG i;
	LONG x;
	BOOL r = TRUE;
	unsigned char bfr[64+1];

	strcpy(lpBuffer, "");

	if (g_nBytesPerLine < 1 || g_nBytesPerLine > 64)
		g_nBytesPerLine = 16;

	for(i=0, x=0;;i++) {

		if(i < size) {
			if(x == 0) {
				// This is the first character of the line. Print line number
				if (g_nLineNumType == 1) {
					// Print Hex
					sprintf(szTemp,"0x%04lx: ", i);
					strcat(lpBuffer, szTemp);
				} else if (g_nLineNumType == 2) {
					// Print Dec
					sprintf(szTemp,"%04ld: ", i);
					strcat(lpBuffer, szTemp);
				} // else do nothing (no line numbers wanted)
			}

			// Print this byte...
			sprintf(szTemp, "%02x ", data[i]);
			strcat(lpBuffer, szTemp);

			// Print the ASCII bit
			bfr[x] = data[i];

			// This converts all non-printable ASCII characters to periods.
			if(bfr[x]<0x20) bfr[x] = '.';
			if(bfr[x]>0x7f) bfr[x] = '.';

		} else {
			// We've got no more data to print, but we need to finish off this line
			if(x==0) {
				break;
			} else {
				strcat(lpBuffer, "   ");
				bfr[x]=' ';
				r=FALSE;
			}
		} 

		x++;

		if((x >= g_nBytesPerLine)) {
			// We've got to the end of the line
			bfr[x]=0;
			if (g_bShowASCII) {
				sprintf(szTemp, "%s", bfr);
				strcat(lpBuffer, szTemp);
			}
			strcat(lpBuffer, "\r\n");	// Add carriage return/newline
			x=0;
			if(r == FALSE) break;
		}
	}
}


///////////////////////////////////////////////////
///////////////////////////////////////////////////
//////////// ListView Control Stuff ///////////////
///////////////////////////////////////////////////
///////////////////////////////////////////////////


// CreateListView - creates a list view control. 
// Returns the handle of the new control if successful or NULL 
//     otherwise. 
// hwndParent - handle of the control's parent window 
// pfData - file containing list view items 
HWND WINAPI
CreateListView(HWND hwndParent) {
	HWND hwndLV;  

    // Force the common controls DLL to be loaded.
	InitCommonControls();  
    // Create the list view window.
	hwndLV = CreateWindow(WC_LISTVIEW, "", 
        WS_CHILD | LVS_REPORT | WS_VISIBLE, 
        0, 0, CW_USEDEFAULT, CW_USEDEFAULT, 
        hwndParent, NULL, g_hInstance, NULL);

	if (hwndLV == NULL) 
        return NULL;  
    // Call application-defined functions to initialize the 
    // image lists, add columns, and add some items. 
    if (!InitListViewImageLists(hwndLV)) { 
        DestroyWindow(hwndLV);
		return FALSE;
	} 
    return hwndLV;              // return the control's handle 
} 

// InitListViewImageList - creates image lists for a list view. 
// Returns TRUE if successful or FALSE otherwise. 
// hwndLV - handle of the list view control 
BOOL WINAPI
InitListViewImageLists(HWND hwndLV) 
{ 
    HICON hiconItem;        // icon for list view items 
    HIMAGELIST himlLarge;   // image list for icon view 
    HIMAGELIST himlSmall;   // image list for other views 
 
    // Create the full-sized and small icon image lists. 
    himlLarge = ImageList_Create(GetSystemMetrics(SM_CXICON),  GetSystemMetrics(SM_CYICON), TRUE, 1, 1); 
    himlSmall = ImageList_Create(GetSystemMetrics(SM_CXSMICON),  GetSystemMetrics(SM_CYSMICON), TRUE, 1, 1); 
 
    // Add an icon to each image list. 
    hiconItem = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_CLIENTITEM)); 
    ImageList_AddIcon(himlLarge, hiconItem); 
    ImageList_AddIcon(himlSmall, hiconItem); 
    DeleteObject(hiconItem); 

    hiconItem = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_SERVERITEM)); 
    ImageList_AddIcon(himlLarge, hiconItem); 
    ImageList_AddIcon(himlSmall, hiconItem); 
    DeleteObject(hiconItem); 

    // Assign the image lists to the list view control. 
    ListView_SetImageList(hwndLV, himlLarge, LVSIL_NORMAL); 
    ListView_SetImageList(hwndLV, himlSmall, LVSIL_SMALL); 
    return TRUE; 
} 
 
void
UpdateListControl(void) {
	int i;
	HMENU hMenu;
	UINT uCheck;

	// Delete columns...
	for (i = 0; i < NUM_COLUMNS; i++)
		ListView_DeleteColumn(g_hListWindow, 0);

	InitListViewColumns();

	if ((hMenu = GetMenu(g_hMainWindow)) == NULL) return;
	if ((hMenu = GetSubMenu(hMenu, 1)) == NULL) return;
	if ((hMenu = GetSubMenu(hMenu, 2)) == NULL) return;

	for (i = 0; i < NUM_COLUMNS; i++) {
		if (i != 0) {
			uCheck = (g_bListBits[i]) ? MF_CHECKED : MF_UNCHECKED;
			CheckMenuItem(hMenu, i-1, MF_BYPOSITION | uCheck);
		}
	}

}

// InitListViewColumns - adds columns to a list view control. 
// Returns TRUE if successful or FALSE otherwise. 
// hwndLV - handle of the list view control 
BOOL WINAPI InitListViewColumns(void) { 
    char achTemp[256];     // temporary buffer 
    LV_COLUMN lvc; 
    int iCol, nNumColsAdded; 
 
    // Initialize the LV_COLUMN structure. 
    lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
    lvc.fmt = LVCFMT_LEFT; 
    lvc.cx = 100; 
    lvc.pszText = achTemp; 
 
    // Add the columns. 
	nNumColsAdded = 0;
    for (iCol = 0; iCol < NUM_COLUMNS; iCol++) { 
		// Always display column zero. Only show other columns if specified...
		if (iCol == 0 || g_bListBits[iCol] == TRUE) {
			lvc.iSubItem = nNumColsAdded; 

			LoadString(g_hInstance, IDS_FIRSTCOLUMN + iCol, achTemp, sizeof(achTemp)); 
			if (ListView_InsertColumn(g_hListWindow, nNumColsAdded, &lvc) == -1) 
				return FALSE; 

			nNumColsAdded++;
		}
    } 
    return TRUE; 
} 
 
// InitListViewItems - adds items and subitems to a list view. 
// Returns TRUE if successful or FALSE otherwise. 
// hwndLV - handle of the list view control 
BOOL WINAPI AddListViewItem(HWND hwndLV, ICQMsg *pICQMsg) 
{ 
    LV_ITEM lvi; 
 
    // Initialize LV_ITEM members that are common to all items. 
    lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
    lvi.state = 0; 
    lvi.stateMask = 0; 
    lvi.pszText = LPSTR_TEXTCALLBACK;   // app. maintains text 
    lvi.iImage = (pICQMsg->bServerMsg) ? 1 : 0;                     // image list index 
 
	{
        // Initialize item-specific LV_ITEM members. 
        lvi.iItem = ListView_GetItemCount(hwndLV);
        lvi.iSubItem = 0; 
        lvi.lParam = (LPARAM) pICQMsg;    // item data 
 
        // Add the item. 
        ListView_InsertItem(hwndLV, &lvi); 
 
        // There is no need to set the text of the subitems. They 
        // default to LPSTR_TEXTCALLBACK. 
    } 
    return TRUE; 
} 

// Main_OnGetDispInfo - processes the LVN_GETDISPINFO 
//     notification message. 
// pnmv - value of lParam (points to an LV_DISPINFO structure) 
VOID WINAPI
Main_OnGetDispInfo(LV_DISPINFO *pnmv) { 
	int nNumColumn, i;

    // Provide the item or subitem's text, if requested. 
    if (pnmv->item.mask & LVIF_TEXT) { 
        ICQMsg *pICQMsg = (ICQMsg *) (pnmv->item.lParam); 

		nNumColumn = -1;
		i = -1;
		while (pnmv->item.iSubItem != nNumColumn && i < NUM_COLUMNS) {
			if (g_bListBits[i+1] == TRUE)
				nNumColumn++;

			i++;
		}

		switch(i) {
			case 0:
				GetCommandName(ICQCommand(pICQMsg), pnmv->item.pszText);
				break;
			case 1:
				lstrcpy(pnmv->item.pszText, pICQMsg->szFrom);
				break;
			case 2:
				sprintf(pnmv->item.pszText, "v%d", ICQVersion(pICQMsg));
				break;
			case 3:
				sprintf(pnmv->item.pszText, "%d,%d", ICQSeqNum1(pICQMsg), ICQSeqNum2(pICQMsg));
				break;
			case 4:
				GetICQMsgTime(pICQMsg, pnmv->item.pszText);
				break;
			case 5:
				lstrcpy(pnmv->item.pszText, pICQMsg->szExtraInfo);
				break;
			default:
				lstrcpy(pnmv->item.pszText, "");
		}
	}
}  

// Main_OnEndLabelEdit - processes the LVN_ENDLABELEDIT 
//     notification message. 
// Returns TRUE if the label is changed or FALSE otherwise. 
// pnmv - value of lParam (points to an LV_DISPINFO structure)  
BOOL Main_OnEndLabelEdit(LV_DISPINFO *pnmv) {
	ICQMsg *pICQMsg;  
	// The item is -1 if editing is being canceled. 
	if (pnmv->item.iItem == -1)
		return FALSE;  
	// Copy the new text to the application-defined structure, 
	// a pointer to which is saved as item data. 
	pICQMsg = (ICQMsg *) (pnmv->item.lParam); 
	//pICQMsg->aCols[0] = (PSTR) LocalReAlloc( (HLOCAL) (pICQMsg->aCols[0]), 
	//	lstrlen(pnmv->item.pszText) + 1, LMEM_MOVEABLE); 
	
	//lstrcpy(pItem->aCols[0], pnmv->item.pszText);  
	// No need to set the item text, because it is a callback item. 
	//return TRUE;

	return FALSE;
}  

// ListViewCompareFunc - sorts the list view control. It is a 
//     comparison function. 
// Returns a negative value if the first item should precede the 
//     second item, a positive value if the first item should 
//     follow the second item, and zero if the items are equivalent. 
// lParam1 and lParam2 - item data for the two items (in this 
//     case, pointers to application-defined MYITEM structures) 
// lParamSort - value specified by the LVM_SORTITEMS message 
//     (in this case, the index of the column to sort) 
int CALLBACK ListViewCompareFunc( LPARAM lParam1,     LPARAM lParam2, 
								 LPARAM lParamSort) { 
    ICQMsg *pICQMsg1 = (ICQMsg *) lParam1; 
	ICQMsg *pICQMsg2 = (ICQMsg *) lParam2;      // Compare the specified column. 

	//int iCmp = lstrcmpi(pItem1->aCols[lParamSort], 	pItem2->aCols[lParamSort]);  
	// Return the result if nonzero, or compare the 
	// first column otherwise.
	//return (iCmp != 0) ? iCmp : lstrcmpi(pItem1->aCols[0], pItem2->aCols[0]);
	return 1;
} 


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

void
OpenPropPage(int nPageToOpen) {

	PROPSHEETHEADER psh;
	PROPSHEETPAGE page[3];

	// show the property page if it already exists
	if (IsWindow(g_hPropPage)) {
		// Set active page...
		PropSheet_SetCurSel(g_hPropPage, NULL, nPageToOpen);
		SetForegroundWindow(g_hPropPage);
		return;
	}

	// It's not open - we need to create it
	InitCommonControls();

	ZeroMemory(page, sizeof(page));
	ZeroMemory(&psh,     sizeof(PROPSHEETHEADER));

	page[PAGE_MAIN].dwSize			= sizeof(PROPSHEETPAGE);
	page[PAGE_MAIN].dwFlags			= PSP_DEFAULT;
	page[PAGE_MAIN].hInstance		= g_hInstance;
	page[PAGE_MAIN].pszTemplate		= MAKEINTRESOURCE(IDD_MAIN_DIALOG);
	page[PAGE_MAIN].pszIcon			= NULL;
	page[PAGE_MAIN].pfnDlgProc		= (FARPROC)MainPageDlgProc;
	page[PAGE_MAIN].lParam			= 0;
	page[PAGE_MAIN].pfnCallback		= 0;

	page[PAGE_SPOOFSERV].dwSize			= sizeof(PROPSHEETPAGE);
	page[PAGE_SPOOFSERV].dwFlags		= PSP_DEFAULT;
	page[PAGE_SPOOFSERV].hInstance		= g_hInstance;
	page[PAGE_SPOOFSERV].pszTemplate	= MAKEINTRESOURCE(IDD_SPOOFSERV_DIALOG);
	page[PAGE_SPOOFSERV].pszIcon		= NULL;
	page[PAGE_SPOOFSERV].pfnDlgProc		= (FARPROC)SpoofServPageDlgProc;
	page[PAGE_SPOOFSERV].lParam			= 0;
	page[PAGE_SPOOFSERV].pfnCallback	= 0;

	page[PAGE_HEXDUMP].dwSize			= sizeof(PROPSHEETPAGE);
	page[PAGE_HEXDUMP].dwFlags			= PSP_DEFAULT;
	page[PAGE_HEXDUMP].hInstance		= g_hInstance;
	page[PAGE_HEXDUMP].pszTemplate		= MAKEINTRESOURCE(IDD_HEXDUMP_DIALOG);
	page[PAGE_HEXDUMP].pszIcon			= NULL;
	page[PAGE_HEXDUMP].pfnDlgProc		= (FARPROC)HexDumpPageDlgProc;
	page[PAGE_HEXDUMP].lParam			= 0;
	page[PAGE_HEXDUMP].pfnCallback		= 0;

	psh.dwSize				= sizeof (PROPSHEETHEADER);
	psh.dwFlags				= PSH_NOAPPLYNOW | PSH_PROPTITLE | PSH_PROPSHEETPAGE | PSH_MODELESS;
	psh.hInstance			= g_hInstance;
	psh.hwndParent			= g_hMainWindow;
	psh.pszIcon				= NULL;
	psh.pszCaption			= (LPSTR) g_szAppName;
	psh.nStartPage			= nPageToOpen;
	psh.nPages				= 3;
	psh.ppsp				= page;
	psh.pfnCallback			= 0;

	g_hPropPage = (HWND)PropertySheet(&psh);
	ShowWindow(g_hPropPage, SW_SHOW);
}


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
void
SetMainControls(HWND hwndDlg, int nSelectedIndex) {
	unsigned int i;
	char szBuffer[256];

	SetDlgItemInt(hwndDlg, IDC_MAIN_PORT_EDIT, GetProxyPort(), FALSE);

	SendDlgItemMessage(hwndDlg, IDC_MAIN_SERVER_LIST, LB_RESETCONTENT, 0, 0);

	for (i = 0; i < g_nNumServers; i++) {
		// Format name...
		sprintf(szBuffer, "%s:%d", g_Servers[i].szServerName, g_Servers[i].nPort);

		// Add this item to top the end of the list box..
		SendDlgItemMessage(hwndDlg, IDC_MAIN_SERVER_LIST, LB_ADDSTRING, 0, (LPARAM)szBuffer);
	}

	// Set server in list...
	SendDlgItemMessage(hwndDlg, IDC_MAIN_SERVER_LIST, LB_SETCURSEL, nSelectedIndex, 0);
}

void
EnableMainButtons(HWND hwndDlg, int nSelectedIndex) {

	if (nSelectedIndex == LB_ERR) {
		EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_REMSERVER_BUTTON), FALSE);
		EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_MOVEUP_BUTTON), FALSE);
		EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_MOVEDOWN_BUTTON), FALSE);
	} else {
		EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_REMSERVER_BUTTON), TRUE);
		if (nSelectedIndex > 0)
			EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_MOVEUP_BUTTON), TRUE);
		else 
			EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_MOVEUP_BUTTON), FALSE);

		if ((unsigned)nSelectedIndex < g_nNumServers-1)
			EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_MOVEDOWN_BUTTON), TRUE);
		else 
			EnableWindow(GetDlgItem(hwndDlg, IDC_MAIN_MOVEDOWN_BUTTON), FALSE);
	}


}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

BOOL CALLBACK
MainPageDlgProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam) {

	char szTempName[256];
	unsigned short nPort, nTempPort;
	int nResult, selectedIndex;
	unsigned int i;

	switch (msg) {
		case WM_DESTROY:
			{
				g_hPropPage = NULL;
			}
			return TRUE;			
		case WM_COMMAND:
			switch(LOWORD(wParam)) {

				case IDC_MAIN_PORT_EDIT:
					if (HIWORD(wParam) == EN_CHANGE) {
						// Update offset
						nPort = (short)GetDlgItemInt(hwndDlg, IDC_MAIN_PORT_EDIT, NULL, FALSE);
						SetProxyPort(nPort);
						return TRUE;
					}
					break;	

				case IDC_MAIN_ADDSERVER_BUTTON:
					nResult = DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_ADDSERVER_DIALOG), hwndDlg, AddServerDlgProc);
					if (nResult == IDOK) {
						// Check g_szNewServerName, g_nNewServerPort are valid...

						// Now add to our list - should check if this fails...
						AddServer(g_szNewServerName, g_nNewServerPort);
						SetMainControls(hwndDlg, -1);
					}
					return TRUE;

				case IDC_MAIN_SERVER_LIST:
					selectedIndex = SendDlgItemMessage(hwndDlg, IDC_MAIN_SERVER_LIST, LB_GETCURSEL, 0, 0);
					EnableMainButtons(hwndDlg, selectedIndex);
					return TRUE;
			
				case IDC_MAIN_REMSERVER_BUTTON:
					// First, get index of selected item to see if we can remove this...
					selectedIndex = SendDlgItemMessage(hwndDlg, IDC_MAIN_SERVER_LIST, LB_GETCURSEL, 0, 0);

					if (selectedIndex != LB_ERR &&
						selectedIndex >= 0 &&
						(unsigned)selectedIndex < g_nNumServers) {

						nResult = MessageBox(hwndDlg, "Are you sure you want to\ndelete this server?", "Delete Particle Source?", MB_ICONQUESTION|MB_YESNO);
						if (nResult == IDYES) {
							g_nNumServers--;

							for (i = selectedIndex; i < (g_nNumServers); i++) {
								strcpy(g_Servers[i].szServerName, g_Servers[i+1].szServerName);
								g_Servers[i].nPort = g_Servers[i+1].nPort;
							}
							SetMainControls(hwndDlg, -1);
							EnableMainButtons(hwndDlg, LB_ERR);
						} 
					}
					return TRUE;
					
				case IDC_MAIN_MOVEUP_BUTTON:
					// First, get index of selected item to see if we can remove this...
					selectedIndex = SendDlgItemMessage(hwndDlg, IDC_MAIN_SERVER_LIST, LB_GETCURSEL, 0, 0);

					// Ensure selectedIndex is valid
					if (selectedIndex != LB_ERR &&
						selectedIndex > 0 &&
						(unsigned)selectedIndex < g_nNumServers) {

						// Copy name, port
						strcpy(szTempName, g_Servers[selectedIndex].szServerName);
						nTempPort = g_Servers[selectedIndex].nPort;

						// Now set to one above..
						strcpy(g_Servers[selectedIndex].szServerName, g_Servers[selectedIndex-1].szServerName);
						g_Servers[selectedIndex].nPort = g_Servers[selectedIndex-1].nPort;

						// Now set the one we've just copied
						strcpy(g_Servers[selectedIndex-1].szServerName, szTempName);
						g_Servers[selectedIndex-1].nPort = nTempPort;

						// Set index # to selectedIndex - 1;
						SetMainControls(hwndDlg, selectedIndex-1);
						EnableMainButtons(hwndDlg, selectedIndex-1);
					}
					return TRUE;

				case IDC_MAIN_MOVEDOWN_BUTTON:
					// First, get index of selected item to see if we can remove this...
					selectedIndex = SendDlgItemMessage(hwndDlg, IDC_MAIN_SERVER_LIST, LB_GETCURSEL, 0, 0);

					// Ensure selectedIndex is valid
					if (selectedIndex != LB_ERR &&
						selectedIndex >= 0 &&
						(unsigned)selectedIndex+1 < g_nNumServers) {

						// Copy name, port
						strcpy(szTempName, g_Servers[selectedIndex].szServerName);
						nTempPort = g_Servers[selectedIndex].nPort;

						// Now set to one below..
						strcpy(g_Servers[selectedIndex].szServerName, g_Servers[selectedIndex+1].szServerName);
						g_Servers[selectedIndex].nPort = g_Servers[selectedIndex+1].nPort;

						// Now set the one we've just copied
						strcpy(g_Servers[selectedIndex+1].szServerName, szTempName);
						g_Servers[selectedIndex+1].nPort = nTempPort;

						// Set index # to selectedIndex + 1;
						SetMainControls(hwndDlg, selectedIndex+1);
						EnableMainButtons(hwndDlg, selectedIndex+1);
					}
					return TRUE;
			}
			break;
		case WM_NOTIFY:
			{
				LPNMHDR pnmh = (LPNMHDR) lParam;
				switch (pnmh->code) {
					case PSN_SETACTIVE:
						{
							// Initialize here
							SetMainControls(hwndDlg, -1);
							EnableMainButtons(hwndDlg, LB_ERR);
						}
						return TRUE;
					case PSN_RESET:
						// Reset changes - read from config data..
						ReadConfig();
						return PSNRET_NOERROR;
					case PSN_APPLY:
						// Save changes - write to config data..
						WriteConfig();
						return PSNRET_NOERROR;
				}
			}
			break;
	}
	return FALSE;
}

// The main callback function for the HexDump dialog proc.
// I'll probably make this into a standard resizable window soon -
// it's a bit restrictive having a fixed size dialog box..
BOOL CALLBACK
AddServerDlgProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam) {

	HWND hwndEdit;

	switch (msg) {
		case WM_INITDIALOG:
			{
				hwndEdit = GetDlgItem(hwndDlg, IDC_ADDSERVER_ADDRESS_EDIT);
				SendMessage(hwndEdit, EM_LIMITTEXT, (WPARAM)sizeof(g_szNewServerName), 0);
			}
			return FALSE;
		//case WM_DESTROY:
		//	return TRUE;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					// Update fields...
					GetDlgItemText(hwndDlg, IDC_ADDSERVER_ADDRESS_EDIT, g_szNewServerName, sizeof(g_szNewServerName));
					g_nNewServerPort = (short)GetDlgItemInt(hwndDlg, IDC_ADDSERVER_PORT_EDIT, NULL, FALSE);

					EndDialog(hwndDlg, IDOK);
					return TRUE;
				case IDCANCEL:
					EndDialog(hwndDlg, IDCANCEL);
					return TRUE;
			}
			break;

	}
	return FALSE;
}


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
void
SetSpoofServControls(HWND hwndDlg) {
	SetDlgItemInt(hwndDlg, IDC_SPOOFSERV_PORT_EDIT, GetSpoofServPort(), FALSE);
}


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

BOOL CALLBACK
SpoofServPageDlgProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam) {

	unsigned short nPort;

	switch (msg) {
		case WM_INITDIALOG:
			{
			}
			return TRUE;
		case WM_DESTROY:
			{
				g_hPropPage = NULL;
			}
			return TRUE;			
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_SPOOFSERV_PORT_EDIT:
					if (HIWORD(wParam) == EN_CHANGE) {
						// Update offset
						nPort = (short)GetDlgItemInt(hwndDlg, IDC_SPOOFSERV_PORT_EDIT, NULL, FALSE);
						SetSpoofServPort(nPort);
						return TRUE;
					}
					break;	
			}
			break;
		case WM_NOTIFY:
			{
				LPNMHDR pnmh = (LPNMHDR) lParam;
				switch (pnmh->code) {
					case PSN_SETACTIVE:
						{
							// Initialize here
							SetSpoofServControls(hwndDlg);
						}
						return TRUE;
					case PSN_RESET:
						// Reset changes - read from config data..
						ReadConfig();
						return PSNRET_NOERROR;
					case PSN_APPLY:
						// Save changes - write to config data..
						WriteConfig();
						return PSNRET_NOERROR;
				}
			}
			break;
	}
	return FALSE;
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
void
SetHexDumpControls(HWND hwndDlg) {

	SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_SHOWHEADER_CHECK, BM_SETCHECK, (WPARAM)(g_bShowHeader) ? BST_CHECKED:BST_UNCHECKED, 0);
	SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_CONCISEHEADER_RADIO, BM_SETCHECK, (WPARAM)(g_bConciseHeader) ? BST_CHECKED:BST_UNCHECKED, 0);
	SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_VERBOSEHEADER_RADIO, BM_SETCHECK, (WPARAM)(!g_bConciseHeader) ? BST_CHECKED:BST_UNCHECKED, 0);

	SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_SHOWBODY_CHECK, BM_SETCHECK, (WPARAM)(g_bShowBody) ? BST_CHECKED:BST_UNCHECKED, 0);
	// This bit sets the line number controls
	{
		SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_LINENUMS_CHECK, BM_SETCHECK, (WPARAM)(g_nLineNumType==0) ? BST_CHECKED:BST_UNCHECKED, 0);
		SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_HEXNUMS_RADIO, BM_SETCHECK, (WPARAM)(g_nLineNumType==1) ? BST_CHECKED:BST_UNCHECKED, 0);
		SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_DECNUMS_RADIO, BM_SETCHECK, (WPARAM)(g_nLineNumType==2) ? BST_CHECKED:BST_UNCHECKED, 0);

		// Do Line number bit...
		if (g_nLineNumType == 0) {
			// Gray out other bits.
			EnableWindow(GetDlgItem(hwndDlg, IDC_HEXDUMP_HEXNUMS_RADIO), FALSE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_HEXDUMP_DECNUMS_RADIO), FALSE);
			
		} else {
			// Enable other bits...

			EnableWindow(GetDlgItem(hwndDlg, IDC_HEXDUMP_HEXNUMS_RADIO), TRUE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_HEXDUMP_DECNUMS_RADIO), TRUE);
		}
	}

	// Line length
	SetDlgItemInt(hwndDlg, IDC_HEXDUMP_BYTESPERLINE_EDIT, g_nBytesPerLine, FALSE);

	// ASCII on/off
	SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_SHOWASCII_CHECK, BM_SETCHECK, (WPARAM)(g_bShowASCII) ? BST_CHECKED:BST_UNCHECKED, 0);

}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

BOOL CALLBACK
HexDumpPageDlgProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam) {
	int nBytesPerLine, nChecked;

	switch (msg) {
		case WM_INITDIALOG:
			{
			}
			return TRUE;
		case WM_DESTROY:
			{
				g_hPropPage = NULL;
			}
			return TRUE;			
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				// Line numbers
				case IDC_HEXDUMP_SHOWHEADER_CHECK:
					{	
						g_bShowHeader = !g_bShowHeader;
						SetHexDumpControls(hwndDlg);
					}
					return TRUE;
				case IDC_HEXDUMP_CONCISEHEADER_RADIO:
				case IDC_HEXDUMP_VERBOSEHEADER_RADIO:
					{	
						//g_bShowHeader = !g_bShowHeader;
						nChecked = SendDlgItemMessage(hwndDlg, IDC_HEXDUMP_CONCISEHEADER_RADIO, BM_GETCHECK, 0, 0);
						g_bConciseHeader = (nChecked == BST_CHECKED) ? TRUE : FALSE;
						SetHexDumpControls(hwndDlg);
					}
					return TRUE;

				case IDC_HEXDUMP_SHOWBODY_CHECK:
					{	
						g_bShowBody = !g_bShowBody;
						SetHexDumpControls(hwndDlg);
					}
					return TRUE;

				case IDC_HEXDUMP_LINENUMS_CHECK:
					{	
						if (g_nLineNumType == 0) g_nLineNumType = 1;
						else g_nLineNumType = 0;
						SetHexDumpControls(hwndDlg);
					}
					return TRUE;
				case IDC_HEXDUMP_HEXNUMS_RADIO:
					{	
						g_nLineNumType = 1;
						SetHexDumpControls(hwndDlg);
					}
					return TRUE;
				case IDC_HEXDUMP_DECNUMS_RADIO:
					{	
						g_nLineNumType = 2;
						SetHexDumpControls(hwndDlg);
					}
					return TRUE;

				// Other formatting stuff
				case IDC_HEXDUMP_BYTESPERLINE_EDIT:
					if (HIWORD(wParam) == EN_CHANGE) {
						// Update offset
						nBytesPerLine = GetDlgItemInt(hwndDlg, IDC_HEXDUMP_BYTESPERLINE_EDIT, NULL, FALSE);
						if (nBytesPerLine < 1) nBytesPerLine = 1;
						if (nBytesPerLine > 64) nBytesPerLine = 64;
						g_nBytesPerLine = nBytesPerLine;
						return TRUE;
					}
					break;	

				case IDC_HEXDUMP_SHOWASCII_CHECK:
					{	
						g_bShowASCII = !g_bShowASCII;
						SetHexDumpControls(hwndDlg);
					}
					return TRUE;


			}
			break;
		case WM_NOTIFY:
			{
				LPNMHDR pnmh = (LPNMHDR) lParam;
				switch (pnmh->code) {
					case PSN_SETACTIVE:
						{
							// Initialize here
							SetHexDumpControls(hwndDlg);
						}
						return TRUE;
					case PSN_RESET:
						// Reset changes - read from config data..
						ReadConfig();
						return PSNRET_NOERROR;
					case PSN_APPLY:
						// Save changes - write to config data..
						WriteConfig();
						return PSNRET_NOERROR;
				}
			}
			break;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////////
//
// Stuff to handle reading.writing registry keys..
//
////////////////////////////////////////////////////////////////////

// Write an integer to the file/section
// The nNumber parameter allows us to create kets like:
// ServerName_1="Wibble"
// ServerName_2="Bob"
void
WriteRegValue(char *szKeyName, int nValue, unsigned int nNumber) {
	char szKeyBuffer[255];
	HKEY hRegKey;
	unsigned long nResult;
	DWORD dwValue = nValue;

	// Append number to Key Name if not 0
	if (nNumber == 0) strcpy(szKeyBuffer, szKeyName);
	else sprintf(szKeyBuffer, "%s_%d", szKeyName, nNumber);

	RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\FunkyFX\\ISpyU",
				 0, "ISpyU", 0, KEY_ALL_ACCESS,
				 NULL, &hRegKey, &nResult);

	RegSetValueEx(hRegKey, szKeyBuffer, 0, REG_DWORD,
		(LPBYTE) &dwValue, sizeof(DWORD));

	RegCloseKey(hRegKey);
}


/////////////////////////////////////////////
// Write a string to the file/section
void
WriteRegString(char *szKeyName, char *szString, unsigned int nNumber) {
	char szKeyBuffer[255];
	HKEY hRegKey;
	unsigned long nResult;

	// Append number to Key Name if not 0
	if (nNumber == 0) strcpy(szKeyBuffer, szKeyName);
	else sprintf(szKeyBuffer, "%s_%d", szKeyName, nNumber);

	RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\FunkyFX\\ISpyU",
				 0, "ISpyU", 0, KEY_ALL_ACCESS,
				 NULL, &hRegKey, &nResult);

	RegSetValueEx(hRegKey, szKeyBuffer, 0, REG_SZ,
		(LPBYTE) szString, strlen(szString)+1);

	RegCloseKey(hRegKey);
}

//////////////////////////////////////////////
// Read a value from .ini file/registry
void
ReadRegValue(char *szKeyName, int *nValue, int nDefault, unsigned int nNumber) {

	char szKeyBuffer[255];
	HKEY hRegKey;
	unsigned long datatype, datasize, nResult;
	DWORD nDWValue;

	// Append number to Key Name if not 0
	if (nNumber == 0) strcpy(szKeyBuffer, szKeyName);
	else sprintf(szKeyBuffer, "%s_%d", szKeyName, nNumber);


	RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\FunkyFX\\ISpyU",
				 0, "ISpyU", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
				 NULL, &hRegKey, &nResult);


	datasize = sizeof(DWORD);
	nResult = RegQueryValueEx(hRegKey, szKeyBuffer, NULL, &datatype, (LPBYTE)&nDWValue, &datasize);

	if (nResult == ERROR_SUCCESS) 
		*nValue = (int)nDWValue;
	else 
		*nValue = nDefault;

	RegCloseKey(hRegKey);
}

////////////////////////////////////////////
// Read a string from .ini file/registry
void
ReadRegString(char *szKeyName,
			  char *szOutBuffer, unsigned int nOutSize,
			  char *szDefaultBuffer,
			  unsigned int nNumber) {

	char szKeyBuffer[255];
	HKEY hRegKey;
	unsigned long datatype, datasize, nResult;

	// Append number to Key Name if not 0
	if (nNumber == 0) strcpy(szKeyBuffer, szKeyName);
	else sprintf(szKeyBuffer, "%s_%d", szKeyName, nNumber);

	RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\FunkyFX\\ISpyU",
				 0, "ISpyU", 0, KEY_ALL_ACCESS,
				 NULL, &hRegKey, &nResult);

	datasize = nOutSize;
	nResult = RegQueryValueEx(hRegKey, szKeyBuffer, NULL,
		&datatype, (LPBYTE)szOutBuffer, &datasize);

	if (nResult != ERROR_SUCCESS)
		strcpy(szOutBuffer, szDefaultBuffer);


	RegCloseKey(hRegKey);
}


// The about dialog proc
BOOL CALLBACK
AboutDlgProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam) {

	switch (msg) {
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					EndDialog(hwndDlg, IDOK);
			}
			break;
	}
	return FALSE;
}
