#ifndef __ISPYUMAIN_H__
#define __ISPYUMAIN_H__

//////////////////////////////////////////////////////////////////
//
// ISpyUMain.h - Defines etc for ISpyU
// 
//   Copyright (C) 1998 Paul Holden
//   paulh@javigate.com
// 
//   File Created: 6  Nov 1998
//   Last Update: 16 Nov 1998
//
//   For more info and more recent version see:
//     http://www.javigate.com/ICQ/
//
//  Standard Disclaimer:
//  --------------------
//    Note that I am in no way affiliate with Mirabilis. I have found all these
//    information by tracing UDP packets (this complies with Mirabilis License
//    agreement). This information are unofficial and may be incorrect.
//
//    This program is provided "as is" and comes with no warranty,
//    express if implied. Use this program at you own risk. Yadda Yadda.

#include <commctrl.h>

#include "ICQMsg.h"

typedef struct {
	char szServerName[128];
	unsigned short nPort;
} ServerInfo;

// Window Messages indicating data is waiting for us at a server or client port
#define WSN_READYFORCLIENTREAD   WM_USER
#define WSN_READYFORSERVERREAD   WM_USER+1
#define WSN_READYFORSPOOFSERVREAD   WM_USER+2

// Window Messages sent to the Output window
#define WM_SETICQMSG WM_USER


// Indexes of pages on the proprty sheet.
#define PAGE_MAIN		0
#define PAGE_SPOOFSERV	1
#define PAGE_HEXDUMP	2

// This is used by IQMsg.c when it adds a message to the linked list
HWND	  g_hListWindow;


// Function Prototypes
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
BOOL InitApplication(void);


BOOL AddServer(char *, unsigned short);

LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK OutputWndProc(HWND, UINT, WPARAM, LPARAM);

void OpenOutputWindow(ICQMsg *);


// Message Handlers and things for the main window
LRESULT Main_Command(HWND, WPARAM, LPARAM);
LRESULT Main_Size(HWND, WPARAM, LPARAM);
HWND WINAPI CreateListView(HWND hwndParent);
BOOL WINAPI InitListViewImageLists(HWND hwndLV);
BOOL WINAPI InitListViewColumns(void);
BOOL WINAPI AddListViewItem(HWND hwndLV, ICQMsg *);
void UpdateListControl(void);
VOID WINAPI Main_OnGetDispInfo(LV_DISPINFO *);
BOOL Main_OnEndLabelEdit(LV_DISPINFO *);
void Main_SetStatus(char *);
int CALLBACK ListViewCompareFunc(LPARAM, LPARAM, LPARAM); 
BOOL WINAPI AddListViewItem(HWND, ICQMsg *);


void OpenMessageFile(HWND);
void SaveMessageFile(HWND);


// Stuff for the output window
void Output_GetMsgText(ICQMsg *, HWND);
void AppendToEdit(HWND, char *);
void HexDump(char *, unsigned char *, int);


// Stuff for the property sheet
void OpenPropPage(int);

void SetMainControls(HWND, int);
void EnableMainButtons(HWND, int);

void SetSpoofServControls(HWND);
void SetHexDumpControls(HWND);

BOOL CALLBACK MainPageDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK SpoofServPageDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK HexDumpPageDlgProc(HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK AddServerDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AboutDlgProc(HWND, UINT, WPARAM, LPARAM);

void ReadConfig(void);
void WriteConfig(void);
void WriteRegValue(char *, int, unsigned int);
void WriteRegString(char *, char *, unsigned int);
void ReadRegValue(char *, int *, int, unsigned int);
void ReadRegString(char *, char *, unsigned int, char *, unsigned int);



#endif