//////////////////////////////////////////////////////////////////
//
// SocketHandler.c - Stuff to handle Winsock etc
// 
//   Copyright (C) 1998 Paul Holden
//   paulh@javigate.com
// 
//   File Created: 6  Nov 1998
//   Last Update: 16 Nov 1998
//
//   For more info and more recent version see:
//     http://www.javigate.com/ICQ/
//
//  Standard Disclaimer:
//  --------------------
//    Note that I am in no way affiliate with Mirabilis. I have found all these
//    information by tracing UDP packets (this complies with Mirabilis License
//    agreement). This information are unofficial and may be incorrect.
//
//    This program is provided "as is" and comes with no warranty,
//    express if implied. Use this program at you own risk. Yadda Yadda.
//
//
//  Comments:
//  ---------
//    As with ISpyUMain.c, this is a work in progress and liable to change lots,
//    so it's not very well commented. This is my first real network app, so it's
//    likely to be bug-ridden to high hell.
//    
//    This was hacked together in an afternoon from some example Microsoft SDK code
//    so there's a lot of useless bits that can be cleaned up

#define WIN32_LEAN_AND_MEAN
#include <winsock2.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "SocketHandler.h"
#include "ISpyUMain.h"
#include "ICQMsg.h"

unsigned short nProxyPort		= DEFAULT_PROXY_PORT;
unsigned short nSpoofServPort	= DEFAULT_SPOOFSERV_PORT;

SOCKET client_socket	= INVALID_SOCKET;
SOCKET server_socket	= INVALID_SOCKET;
SOCKET spoofserv_socket	= INVALID_SOCKET;

struct sockaddr_in lastfrom;

BOOL g_bWSOpen			= FALSE;


// Attempt to initialize WinSock library. Returns TRUE on
// success, FALSE otherwise...
BOOL
InitWinSock(void) {
	WSADATA wsaData;

	if (g_bWSOpen == TRUE) return TRUE;

	// Firstly, we need to initialise WinSock
	if (WSAStartup(0x202,&wsaData) != SOCKET_ERROR)
		g_bWSOpen = TRUE;

	return g_bWSOpen;
}

// Make WinSock clean up
void
FiniWinSock(void) {
	WSACleanup();
	g_bWSOpen = FALSE;		// Set our flag to false so we know to re-open WinSoc is necessary
}

unsigned short
GetProxyPort(void) {
	return nProxyPort;
}

void
SetProxyPort(unsigned short nNewPort) {
	// If we already chare a port open, close it and open one on this
	// new number.
	if (client_socket != INVALID_SOCKET) {
		// Close, and reopen with new number..

	}

	nProxyPort = nNewPort;
}


unsigned short
GetSpoofServPort(void) {
	return nSpoofServPort;
}

void
SetSpoofServPort(unsigned short nNewPort) {
	// If we already chare a port open, close it and open one on this
	// new number.
	if (spoofserv_socket != INVALID_SOCKET) {
		// Close, and reopen with new number..

	}

	nSpoofServPort = nNewPort;
}

// Set up sockets to communicate with ICQ server and ICQ Client
BOOL
InitClientSocket(HWND hWindow, char *szBuffer) {
	struct sockaddr_in client;

	// Open WinSock (if it's already open InitWinSock() doesn't do anything)
	if (InitWinSock() == FALSE) {
		// WSAGetLastError will have been set by call to InitWinSock
		sprintf(szBuffer,"Couldn't open WinSock. (%d)",WSAGetLastError());
		return FALSE;
	}

	// Initialise the client info
	memset(&client, 0, sizeof(client));
	client.sin_family = AF_INET;
	client.sin_addr.s_addr = INADDR_ANY; 
	client.sin_port = htons(nProxyPort);

	// Create our socket now...
	client_socket = socket(AF_INET, SOCK_DGRAM,0);
	
	if (client_socket == INVALID_SOCKET){
		sprintf(szBuffer,"Client: socket() failed. (%d)",WSAGetLastError());
		return FALSE;
	}

	// bind() associates a local address and port combination with the
	// socket just created. This is most useful when the application is a 
	// server that has a well-known port that clients know about in advance.
	//
	if (bind(client_socket, (struct sockaddr*)&client, sizeof(client) ) == SOCKET_ERROR) {
		sprintf(szBuffer,"Client: bind() failed. (%d)",WSAGetLastError());
		return FALSE;
	}

	// WSAsyncSelect causes Winsock to send us messages to our Window Msg loop
	// when data becomes available at port. This allows us to do other stuff
	// rather than being blocked, waiting for info to arrive at the port
    if (WSAAsyncSelect(client_socket, hWindow, WSN_READYFORCLIENTREAD, FD_READ) == SOCKET_ERROR) {
		sprintf(szBuffer, "Client: WSAsyncSelect Failed");
        return FALSE;
    }

	sprintf(szBuffer, "Sockets initialized ok.");
	return TRUE;
}

BOOL
InitServerSocket(HWND hWindow, char *szServerName, unsigned short nPort, char *szBuffer) {
	struct sockaddr_in server;
	struct hostent *hp;

	// Open WinSock (if it's already open InitWinSock() doesn't do anything)
	if (InitWinSock() == FALSE) {
		// WSAGetLastError will have been set by call to InitWinSock
		sprintf(szBuffer,"Couldn't open WinSock. (%d)",WSAGetLastError());
		return FALSE;
	}

	/////////////////////////////////////////
	// Set up DGRAM port to ICQ server
	// Should check if szServerName is in dotted format ("x.x.x.x")
	hp = gethostbyname(szServerName);
	if (hp == NULL) {
		sprintf(szBuffer,"Server: Cannot resolve address '%s'. (%d)", szServerName, WSAGetLastError());
		return FALSE;
	}

	// Initialise server info
	memset(&server, 0, sizeof(server));
	memcpy(&(server.sin_addr), hp->h_addr, hp->h_length);
	server.sin_family = hp->h_addrtype;
	server.sin_port = htons(nPort);

	server_socket = socket(AF_INET,SOCK_DGRAM,0); // Open a socket
	if (server_socket == SOCKET_ERROR) {
		sprintf(szBuffer,"Server: socket() failed. (%d)",WSAGetLastError());
		return FALSE;
	}

	if (connect(server_socket, (struct sockaddr*)&server, sizeof(server)) == SOCKET_ERROR) {
		sprintf(szBuffer,"Server: connect() failed. (%d)",WSAGetLastError());
		return FALSE;
	}

	// Make WinSock send messages to out msg loop when data is ready
    if (WSAAsyncSelect(server_socket, hWindow, WSN_READYFORSERVERREAD, FD_READ) == SOCKET_ERROR)
    {
		sprintf(szBuffer, "Client: WSAsyncSelect Failed");
        return FALSE;
    }

	sprintf(szBuffer, "Sockets initialized ok");
	return TRUE;
}

// Initialise our socket for sending spoof information back to clients
BOOL InitSpoofServerSocket(HWND hWindow, char *szBuffer) {
	struct sockaddr_in spoof;

	// Open WinSock (if it's already open InitWinSock() doesn't do anything)
	if (InitWinSock() == FALSE) {
		// WSAGetLastError will have been set by call to InitWinSock
		sprintf(szBuffer,"Couldn't open WinSock. (%d)",WSAGetLastError());
		return FALSE;
	}

	// Initialise the client info
	memset(&spoof, 0, sizeof(spoof));
	spoof.sin_family = AF_INET;
	spoof.sin_addr.s_addr = INADDR_ANY; 
	spoof.sin_port = htons(nSpoofServPort);

	// Create our socket now...
	spoofserv_socket = socket(AF_INET, SOCK_DGRAM,0);
	
	if (spoofserv_socket == INVALID_SOCKET){
		sprintf(szBuffer,"SpoofServ: socket() failed. (%d)",WSAGetLastError());
		return FALSE;
	}

	// bind() associates a local address and port combination with the
	// socket just created. This is most useful when the application is a 
	// server that has a well-known port that clients know about in advance.
	//
	if (bind(spoofserv_socket, (struct sockaddr*)&spoof, sizeof(spoof) ) == SOCKET_ERROR) {
		sprintf(szBuffer,"SpoofServ: bind() failed. (%d)",WSAGetLastError());
		return FALSE;
	}

	// WSAsyncSelect causes Winsock to send us messages to our Window Msg loop
	// when data becomes available at port. This allows us to do other stuff
	// rather than being blocked, waiting for info to arrive at the port
    if (WSAAsyncSelect(spoofserv_socket, hWindow, WSN_READYFORSPOOFSERVREAD, FD_READ) == SOCKET_ERROR) {
		sprintf(szBuffer, "SpoofServ: WSAsyncSelect Failed");
        return FALSE;
    }

	sprintf(szBuffer, "Sockets initialized ok.");
	return TRUE;

}

// Read a message from the client
ICQMsg *
ProcessClientSocket(HWND hWindow, char *szStatus) {
	ICQMsg *pICQMsg;
	int fromlen = sizeof(lastfrom);
	int retval;
	unsigned long nMsgLen;

	// Check how much data is waiting...
	if (ioctlsocket(client_socket, FIONREAD, &nMsgLen) != 0) {
		// Socket error
		sprintf(szStatus, "ClientICQMsg: No data at port?\r\n");
		return NULL;
	}

	if (nMsgLen == 0) {
		sprintf(szStatus, "ClientICQMsg: No data\r\n");
		return NULL;
	}

	pICQMsg = CreateICQMsg(nMsgLen, FALSE);
	if (pICQMsg == NULL) {
		sprintf(szStatus, "ClientICQMsg: Couldn't allocate memory for ICQMsg\r\n");
		return NULL;
	}

	retval = recvfrom(client_socket, pICQMsg->pData, nMsgLen, 0,
								 (struct sockaddr *)&lastfrom, &fromlen);
		
	if (retval == SOCKET_ERROR || retval != (signed)nMsgLen) {
		sprintf(szStatus,  "ClientICQMsg: recv() failed: error %d\r\n",WSAGetLastError());
		DestroyICQMsg(pICQMsg);
		return NULL;
	}

	// Get szInetAddr, port etc
	ProcessICQMsg(pICQMsg, &lastfrom);

	// Pass on message to ICQ Server
	SendToServerSocket(pICQMsg, NULL);
	//retval = send(server_socket, (char *)pICQMsg->pData, pICQMsg->nMsgLen,0);

	// Ignore retval for the time being...

	sprintf(szStatus,  "ClientICQMsg: Got message Ok\r\n");

	return pICQMsg;
}

ICQMsg *
ProcessServerSocket(HWND hWindow, char *szStatus) {

	ICQMsg *pICQMsg;
	struct sockaddr_in from;
	int fromlen = sizeof (from);
	int retval;
	unsigned long nMsgLen;

	// Check how much data is waiting...
	if (ioctlsocket(server_socket, FIONREAD, &nMsgLen) != 0) {
		// Socket error
		sprintf(szStatus, "ServerICQMsg: No data at port?\r\n");
		return NULL;
	}

	pICQMsg = CreateICQMsg(nMsgLen, TRUE);
	if (pICQMsg == NULL) {
		sprintf(szStatus, "ServerICQMsg: Couldn't allocate memory for ICQMsg\r\n");
		return NULL;
	}

	retval = recvfrom(server_socket, (char *)pICQMsg->pData, nMsgLen, 0,
									  (struct sockaddr *)&from, &fromlen);
		
	if (retval == SOCKET_ERROR || retval != (signed)nMsgLen) {
		sprintf(szStatus,  "ServerICQMsg: recv() failed: error %d\r\n",WSAGetLastError());
		DestroyICQMsg(pICQMsg);
		return NULL;
	}

	// Get szInetAddr, port etc
	ProcessICQMsg(pICQMsg, &from);

	// Pass on message to ICQ client...
	SendToClientSocket(pICQMsg, &lastfrom);
	//retval = sendto(client_socket, (char *)pICQMsg->pData, pICQMsg->nMsgLen,0,
	//				(struct sockaddr *)&lastfrom, sizeof(lastfrom));

	sprintf(szStatus,  "ServerICQMsg: Got message Ok\r\n");
	return pICQMsg;
}

void
ProcessSpoofServSocket(HWND hWindow, char *szStatus) {
	ICQMsg *pICQMsg;
	struct sockaddr_in from;
	int fromlen = sizeof (from);
	int retval;
	unsigned long nMsgLen;

	// Check how much data is waiting...
	if (ioctlsocket(spoofserv_socket, FIONREAD, &nMsgLen) != 0) {
		// Socket error
		sprintf(szStatus, "SpoofServICQMsg: No data at port?\r\n");
		return;
	}

	pICQMsg = CreateICQMsg(nMsgLen, FALSE);
	if (pICQMsg == NULL) {
		sprintf(szStatus, "SpoofServICQMsg: Couldn't allocate memory for ICQMsg\r\n");
		return;
	}

	retval = recvfrom(spoofserv_socket, (char *)pICQMsg->pData, nMsgLen, 0,
									  (struct sockaddr *)&from, &fromlen);
		
	if (retval == SOCKET_ERROR || retval != (signed)nMsgLen) {
		sprintf(szStatus,  "SpoofServICQMsg: recv() failed: error %d\r\n",WSAGetLastError());
		DestroyICQMsg(pICQMsg);
		return;
	}

	// Get szInetAddr, port etc
	ProcessICQMsg(pICQMsg, &from);

	// Pass on reply to ICQ client...
	RespondToMessage(pICQMsg, &from, szStatus);

	//retval = sendto(client_socket, (char *)pICQMsg->pData, pICQMsg->nMsgLen,0,
	//				(struct sockaddr *)&from, sizeof(from));

	//sprintf(szStatus,  "SpoofServICQMsg: Got message Ok\r\n");
}

void
SendToClientSocket(ICQMsg *pICQMsg, struct sockaddr_in *to) {

	int retval;

	// Pass on message to ICQ client...
	retval = sendto(client_socket, (char *)pICQMsg->pData, pICQMsg->nMsgLen,0,
					(struct sockaddr *)to, sizeof(struct sockaddr_in));


}

void
SendToServerSocket(ICQMsg *pICQMsg, struct sockaddr_in *to) {

	int retval;

	// Pass on message to ICQ server
	retval = send(server_socket, (char *)pICQMsg->pData, pICQMsg->nMsgLen,0);
}

void
SendUsingSpoofServSocket(ICQMsg *pICQMsg, struct sockaddr_in *to) {

	int retval;

	// Pass on message to ICQ server
	retval = sendto(spoofserv_socket, (char *)pICQMsg->pData, pICQMsg->nMsgLen,0,
					(struct sockaddr *)to, sizeof(struct sockaddr_in));

}